// ̧قDoxygenpɏĂ܂B
/*! \file ********************************************************************
*
* Atmel Corporation
*
* - ̧		: calibration.h
* - ߲		: IAR EWAVR 4.11A
*
* - xҰ		: avr@atmel.com
*
* - x޲	: ATmega406̂
*
* - pLq	: AVR453 - dr/ATAVRSB100
*
* - 		: Zp̒`ƕϐ
*
* - 		: RKS
* - 		: $Revision: 1.27 $
* - t		: $Date: 2005N99() 10:27:38 UTC $
* - XV		: $Author: rksnilsberg $
*
*****************************************************************************/

// ^錾
unsigned char CalibrateVREF(void);		// VREFpZٰ
unsigned char CalibrateCCoffset(void);	// CCψ(̾)pZٰ


#ifdef MODULE_CALIBRATION
unsigned int calibration_state = 0;
unsigned int calibration_state_req = 0;
#define CCoffset_limit		100			// (߂ׂ)CCoffsetpx
#define CCIoffset_limit		66			// CCIoffsetpx 10.5~(CCoffset/16)

// ̕4096mVł̾1ł̍ZpłB
#define CAL_CHANNEL 		0x01		// ADC0ٗpdl
#define CAL_GAIN			ADCgain[0]	// ADC0ٗpl
#define CAL_WAIT			10			// ٕť덷ŏ҂̂߂VADC(512s)

// (xvŕꂽ)e퉷xˑZݒ`
#define TempCal0			0x00
#define TempCal1			0x01
#define TempCal2			0x03
#define TempCal3			0x07
#define TempCal4			0x0F
#define TempCal5			0x1F
#define TempCal6			0x3F
#define TempCal7			0x7F
#define TempCal8			0xFF

//! /todo Vcalibrationl͓͐dŒ߂ȂȂȂ܂B
#define Vcalibration_value	67117056		// ͓d=4096.5mV~16384/mV=67117056
//#define Vcalibration_value	67094442	// ޯޓ͓d=4096.5mV~60BC/mV~1.10055/1.100
#define VLevel0				0				// <VLevel1̏ꍇTempcal0߂̌
#define VLevel1				-615753			// b
#define VLevel2				-491700
#define VLevel3				-337272
#define VLevel4				-152886
#define VLevel5				0
#define VLevel6				60960
#define VLevel7				121810
#define VLevel8				182549

// ̕0.55VłADC0̍ZpŁAZ@肳ꂽɏCׂłB
/*
#define CAL_CHANNEL 		0x07	// ADC0ٗpdl
#define CAL_GAIN			1		// ׂ߲ɂčœKꂽ@Ŏړxꂽ͂Ƃ̌݊^邽߂
									// ǉBړxȂ͂gꍇAٰ݂œK邱Ƃł܂B
#define CAL_WAIT			1		// CellBalancinǧ덷ŏҋ@̂߂VADC(512s)BUǂݍ݂ɑ
									// ď1҂܂B

// (xvŕꂽ)e퉷xˑZݒ`
#define TempCal0			0x00
#define TempCal1			0x01
#define TempCal2			0x03
#define TempCal3			0x07
#define TempCal4			0x0F
#define TempCal5			0x1F
#define TempCal6			0x3F
#define TempCal7			0x7F
#define TempCal8			0xFF

#define Vcalibration_value	2048	// ͓d=0.55VŎgp(͈̔)
#define VLevel1				-18		// ɎgpAlTBD
#define VLevel2				-15
#define VLevel3				-10
#define VLevel4				-5
#define VLevel5				0
#define VLevel6				2
#define VLevel7				4
#define VLevel8				6
*/

__flash unsigned char tempcal[] = {TempCal0,TempCal1,TempCal2,TempCal3,TempCal4,TempCal5,TempCal6,TempCal7,TempCal8};
__flash signed long int vcalibration_level[] = {VLevel0,VLevel1,VLevel2,VLevel3,VLevel4,VLevel5,VLevel6,VLevel7,VLevel8};

#else
  extern unsigned int calibration_state;
  extern unsigned int calibration_state_req;
#endif


// Zϐp`

#define CAL_VREF_BIT_POS	0
#define CAL_CC_BIT_POS		2

#define NO_CAL				0
#define RUN_CAL				1
#define CAL_FAIL			2
#define CAL_OK				3

#define CAL_VREF_MASK		(3        << CAL_VREF_BIT_POS)
#define CAL_VREF_RUN		(RUN_CAL  << CAL_VREF_BIT_POS)
#define CAL_VREF_FAIL		(CAL_FAIL << CAL_VREF_BIT_POS)
#define CAL_VREF_OK			(CAL_OK   << CAL_VREF_BIT_POS)

#define CAL_CC_MASK			(3        << CAL_CC_BIT_POS)
#define CAL_CC_RUN			(RUN_CAL  << CAL_CC_BIT_POS)
#define CAL_CC_FAIL			(CAL_FAIL << CAL_CC_BIT_POS)
#define CAL_CC_OK			(CAL_OK   << CAL_CC_BIT_POS)
