// ̧قDoxygenpɏĂ܂B
/*! \file ********************************************************************
*
* Atmel Corporation
*
* - ̧		: main.h
* - ߲		: IAR EWAVR 4.11A
*
* - xҰ		: avr@atmel.com
*
* - x޲	: ATmega406̂
*
* - pLq	: AVR453 - dr/ATAVRSB100
*
* - 		: main.cpͯ ̧
*
* - 		: rgf-apt
* - 		: $Revision: 1.27 $
* - t		: $Date: 2005N99() 10:27:38 UTC $
* - XV		: $Author: rksnilsberg $
*
*****************************************************************************/

#define OP_MODE_FULL	0
#define OP_MODE_STDBY	1
#define OP_MODE_SLEEP	2

#ifdef MODULE_MAIN
  unsigned char action_flags = 0;
  unsigned char OperatingMode = OP_MODE_FULL;
#else
  extern unsigned char action_flags;
  extern unsigned char OperatingMode;
#endif

#define QTRSECFLAG		1
#define ADCDONEFLAG		2
#define ALARMMODEFLAG	4
#define MASTERSMBDONE	8
#define CALIBREQUESTED	16


#define CheckADCScanDone	(action_flags & ADCDONEFLAG)
#define SetADCScanDone		{action_flags |= ADCDONEFLAG;}
#define ClrADCScanDone		{action_flags &= ~ADCDONEFLAG;}

#define CheckQtrSec			(action_flags &  QTRSECFLAG)
#define SetQtrSec			{action_flags |= QTRSECFLAG;}
#define ClrQtrSec			{action_flags &= ~QTRSECFLAG;}

#define CheckAlarmMode		(action_flags &  ALARMMODEFLAG)
#define SetAlarmMode		{action_flags |= ALARMMODEFLAG;}
#define ClrAlarmMode		{action_flags &= ~ALARMMODEFLAG;}

#define CheckMasterSMBdone	(action_flags & MASTERSMBDONE)
#define SetMasterSMBdone	{action_flags |= MASTERSMBDONE;}
#define ClrMasterSMBdone	{action_flags &= ~MASTERSMBDONE;}

#define CheckCalibRequest	(action_flags & CALIBREQUESTED)
#define SetCalibRequest		{action_flags |= CALIBREQUESTED;}
#define ClrCalibRequest		{action_flags &= ~CALIBREQUESTED;}
