// ̧قDoxygenpɏĂ܂B
/*! \file ********************************************************************
*
* Atmel Corporation
*
* - ̧		: smbus.c
* - ߲		: IAR EWAVR 4.11A
*
* - xҰ		: avr@atmel.com
*
* - x޲	: ATmega406̂
*
* - pLq	: AVR453 - drQƊ݌v
*
* - 		: SMBus(TWIʺނƖ߉ߕ)
*
* - 		: rgf-apt
* - 		: $Revision: 1.27 $
* - t		: $Date: 2005N99() 10:27:42 UTC $
* - XV		: $Author: rksnilsberg $
*
*****************************************************************************/

// ꗗ:
//	2005N613: Mł̌C(޲Čv̎gpǉ)
//	2005N6 6: ްoSMLOCK̉ǉ
//	2005N6 5: 100kHzɂ邽TWBȐl11̑12ɕύX
//	2005N510: 呕uMԂTWBȐǉ


#include "pgmspace.h"
#include <inavr.h>

#define MODULE_SMBUS		/* smbus.hŕϐ̎̉ۏ */
#include "smbus.h"			// ϐׯ̎̉

#include "timer.h"			// BusFaultvLɕKv
#include "pack.h"			// ̌vZɕKv
#include "analog.h"			// SMBus۸ތvZɕKv
#include "calibration.h"	// SMBus۸ތvZɕKv
//#include "iom406_320.h"
#include <iom406.h>			// ATmega406pIAR(EW 410)ͯ ̧
#include "interpret.h"		// ̒Pʕɂ̧قݸٰ
#include "main.h"
#include "pwrmgmt.h"


//extern __flash unsigned char SM_Cmd_Table[0x40][2];	// interpret.c
typedef unsigned char (*ptr2funcUC_V)(void);
extern ptr2funcUC_V SMB_ReadCmd[];
extern ptr2funcUC_V SMB_WriteCmd[];

// IɕKvƂ錴^錾
unsigned char FastCRC(unsigned char LastCRC, unsigned char newbyte);
//extern unsigned char SMLOCK;

// SMBusߔ͈͊OɎg܂B
#define HIGHEST_SMB_CMD 0x3F

// 2̪ TWSR()l
// Ou킪0̂ߏ޲Ă̎ՕsvȂƂɒӂĂB

// L͈͂ɓKpłTWIԕ
#define TWS_MASK		0xF8	/* 2ԎՕ */
#define TWS_NSTAT		0xF8	/* ݏԗps */

// 呕u֘Aԕ:
#define TWS_START		0x08
#define TWS_RESTART		0x10
#define TWS_WRITE_ACK	0x18	/* SLA+WoAACK擾 */
#define TWS_WRITE_NAK	0x20	/* SLA+WoANAK擾 */
#define TWS_TXDATA_ACK	0x28	/* ްMAACKԓ */
#define TWS_TXDATA_NAK	0x30	/* ްMANAKԓ */
#define TWS_LOST_ARB	0x38	/* ޽s */

#define TWS_READ_ACK	0x40	/* SLA+RvACK擾 */
#define TWS_READ_NAK	0x48	/* SLA+RvNAK擾 */
#define TWS_RXDATA_ACK	0x50	/* ްMAACKԓ */
#define TWS_RXDATA_NACK	0x58	/* ްMANAKԓ */

// ]u֘Aԕ
#define TWS_SLA_W		0x60	/* SLA+ݎ擾 */
#define TWS_SLA_R		0xA8	/* SLA+ǂݍݎ擾 */
#define TWS_RDATA		0x80	/* ް ޲Ď擾 */
#define TWS_RCMD		0x80	/* ޲Ď擾 */
#define TWS_RSTOP		0xA0	/* ~擾 */
#define TWS_REPEAT		0xA0	/* đJn擾 */
#define TWS_RACK		0xB8	/* ް ޲đoAACKԓ擾 */
#define TWS_RNAK		0xC0	/* ް ޲đoANAKԓ擾 */
#define TWS_FINAL		0xC8	/* ŏI޲đoAACKԓ擾 */
#define TWS_BERR		0x00	/* ޽ُɑ */

// 2l

#define TWC_GO			0x85	/* TWINT; Ɗ荞݋L */
#define TWC_READ_NoACK	0x85	/* ޲ēǂݍ݁AIACKȂ */
#define TWC_START		0xA5	/* JnޯďoAƊ荞݋L */
#define TWC_STOP		0x94	/* IɊ荞݂֎~*̂܂ */
#define TWC_RESTART		0xB5	/* ~ǍɍĂъJn𑗏oA荞݋ */


/* ************************************************************************* */

unsigned char TEST50US = 0;
unsigned char SMLOCK = 0;			// ޽呕ůԂɎ呕u޽ߑh~

unsigned char TW_MTxBuf[8];			// 呕u쑗MɏՕ
unsigned char TW_MTxBufCnt = 0;		// ǂ̈ʗL޲ĂɏՕɂ邩
unsigned char TW_MTxBufIndex = 0;

// ̊ɏՕɂāA͈ȉ܂߂Ȃ΂ȂȂƂɒ
// ]uڽASMBus߁A޲Čv(򓮍̏ꍇ)Aő32޲āA+PEC
unsigned char TW_TxBuf[36];			// očsǂ̕ɑ΂Ă[ȒłȂ΂Ȃ܂B
unsigned char TW_TxBufCnt = 0;		// ǂ̈ʗL޲ĂɏՕɂ邩
unsigned char TW_TxBufIndex = 0;

unsigned char TW_RxBuf[10];			// p(ISP)ŁAꖽ߂M
signed char TW_RxBufCnt = 0;
unsigned char TW_RxBufIndex = 0;

// ޲Ă͕\ނɉsTWI ISR׸ނ܂݂܂B޲Ă0
// łA\ނ͂̓eœ܂BISRƕ\ނ̗ɂď
// ܂A\ނ֘AߏIĂ׸ ޲Ă܂SMBBus
// ~邽VOLATILE錾͕svłB
unsigned char TWI_CmdFlags;
  #define SMB_GenBusTimeout		1	/* ُ푘̂߁A\ނ޽Ԑ܂!B */
  #define SMB_SetUpReply		2	/* \ނTW_TxBuf[]܂B */
  #define SMB_GotCmdData		4	/* \ނɎMSȖ߂߂܂B */

unsigned char CurrentCmd = 0xFF;
unsigned char UsePEC = 0;			// ɂPECgp֎~܂B


/* *************************************************************************
 *
 *   SMBusٰ
 *
 ************************************************************************* */

void InitSMBus(void)
{
	SMB_RestoreBus();
	TWBCSR = (1<<TWBCIF) | (1<<TWBCIE) | (1<<TWBDT1) | (1<<TWBDT0) | (0<<TWBCIP);
}

/* *************************************************************************
 *
 *   SMBusNオ芄荞
 *
 ************************************************************************* */

// ͋x~삩"ON"ԂɓdrN܂Bsbdat110, 4.4.2

#pragma vector = TWI_BUS_CD_vect
__interrupt void TWICD_ISR(void)
{
	// sbdat110, 4.4.2ɑ΂ޯĉ
	SMBvariables[SMBV_BattMode][hibyte] &= ~(0xE3);	

	if(TWBCSR & (1<<TWBCIP))	// ̊荞݂޽ؒfۂɂċN܂B
	{
		TWBCSR &= ~(1<<TWBCIP);
		ChangePowerMode(POWERMODE_IDLE,0);
	}
	else	// ̊荞݂޽ڑۂ̂߂ɋN܂B
	{
		TWBCSR |= (1<<TWBCIP);
		ChangePowerMode(POWERMODE_ACTIVE,0);
	}
}

/* *************************************************************************
 *
 *   SMBus PA6ݕω荞 (呕uɑ΂ĕKvƂ܂B)
 *
 ************************************************************************* */


#pragma vector = PCINT0_vect
__interrupt void PCINT0_ISR(void)
{
	TEST50US = 0;		// ޽SMBUS.Cɍ}
}

#pragma vector = PCINT1_vect
__interrupt void PCINT1_ISR(void)
{
	;		// gp
}

/* *************************************************************************
 *
 *   SMBusʐMԋ@\
 *
 ************************************************************************* */

/*

]u
-------------

呕u
-------------

呕u͕\ނɂĎn߂܂B(\IɌvo߂̂߂)үނ
uoRł̑Mɗp\ȎɂTWI呕uMɏՕɒu܂B
ǂA"޽呕u50s޽ َԌKvƂ"SMBusv̂߁AM
͒Ɏn߂邱Ƃł܂B

̗v𖞂߁A޽ ُԂĎ̂AVRݕϊo@\gA
PA5͂̋@\߂ɊOISMBCLKM(CONN15)ɔzȂ΂
܂(]܂ꂽȂAɁAgp҂̐iтŁAݕω\͂ǂꂩ
I/OMPA5̑ɎgƂł܂)BPA5޽̑̑uɂĈ
ꂽԂɑ΂LowێĂSMCLK𒲂ׂ邾łȂAAVRgǏIɂ
sĂꍇɒׂ̂ɂg܂B

޽̗Lۏ؂邽߂3iK̼тg܂BŏɑMɏՕү
݂͎̑呕u\ނ̎sɋA܂Bɏ]uԋ@\
ُԂłȂ΁A޽̐鎎݂͍s܂BŌPA5ݘ_0Ԃ
Ȃ̂mɂ邽߂PA5ׂ܂B̎_ŁA޽͋󂫂ƎvÂ
50sn܂Ƃ(TEST50USƌĂ΂)׸ނLɂAPA5p
ݕω荞݂܂B̌ɕ\SMBus呕u쏈o܂B1MHz
̸ۯxŁA50s͑Ă50߂ɂΉ܂B]āAނē
ꂽɍŒ50s߂Ă邱Ƃۏ؂܂B

ݕω荞݂̎޽ݕω荞݂N܂BΉISR
TEST50US׸ނA޽łȂƂ܂B]āA\ނēꂽ
׸ނLɂꂸɊɏՕүނꍇAsɂčĂъJn
Ȃ΂ȂȂƔfA]āA׸ނ͍ĂїLɂٰ݂o܂B

₪ĖLɂꂽ׸ނƋɕ\ނēAPA5݂LowłȂATWI ISR]
uԋ@\قȂA޽̊ԂɒɑMJn銈܂B\
ނүނɑ΂ČJԂđMn߂悤ƂȂ悤ɁA呕u삪TWI
ʰ޳ɂĈڍsꂽ̂ߕtIȘA׸(SMLOCK)Lɂ܂B
׸ނŌɗLɂꂽISRɂ꓾\̂߁AُԊ
ɒ邱ƂKvƂ邱ƂɒӂĂBāAꂽԂ̂
߂ɕʂ̏]uSMCLKLowɕێ邱Ƃɂ޽~邱Ƃ\ŁÂ
޽낤ƂOɂׂ邱ƂKvłB

AVR޽̏LlɐꍇA]񂾏]uڽ̑M0x??̏ԕ
ƋISR܂BʂƂāAԋ@\͍呕u쑗MɊ֘A
ԂAISRM̍XȂSĂ̖ʂ܂BɁATWIPʕ޽l
ȂꍇATWI ISRɈڍs܂AُԕƋ
łB҂̏ꍇASMLOCKTEST50US׸ނ͏ʂ޽l݂̎邽߂
܂B

*/

unsigned char TXmsg[4][4];				// PECp̏ꏊc܂B
volatile unsigned char TXmsgHead = 0;
volatile unsigned char TXmsgTail = 0;
volatile unsigned char TXmsgQty = 0;

#define TXmsgEmpty (TXmsgQty == 0)
#define TXmsgFull (TXmsgQty == 4)
#define TXmsgDelete {++TXmsgTail; TXmsgTail &= (4-1);  TXmsgQty--;}

// Xүނɑ΂PECvZ
void MasterInsertMsg(unsigned char addr, unsigned char cmd, unsigned int data)
{	// [dڽ0x12ł邱ƂɒӂĂ! (sbsm100.pdf, 5.2)B
	// ν ڽ͏0x16łB
	// sddr͏ɏ݂Ɖ
	// ꏑ݂s܂B

	unsigned char * ptr = TXmsg[TXmsgHead];

	*ptr++ = addr;
	*ptr++ = cmd;
	*ptr++ = (unsigned char) data;
	*ptr = (unsigned char)(data>>8);

	if(TXmsgFull)
		return;

	++TXmsgHead;
	TXmsgHead &= (4-1);
	TXmsgQty++;
}

// TWI荞ݏٰ
// ISR͒޽ʐMԋ@\܂݂܂B\ނɊÂ߉ߕү
// ޏ̕Kv`邽߂TWI_CmdFlagsϐg܂B\ٰ݂ɐn
// ͕KSMBus~܂B

/* 2005N617ȍ~SMBusԋ@\̓쌒N (rgf):

   ޽Ōdrڽw肷镡̎呕uAAνĂ܂͏[d킪蓾邽
   ߁A1̎呕uPECxőxȂƂSɂ蓾܂B
   őM̂߁AߋɎgĂۂɊւ炸AsPEC̎Mx
   邱ƂłȂ΂Ȃ܂B

   ̂悤ɍs߁APECȂŗ\ꂽ޲Đ߂܂BMƓɂ̌v
   炵A(a)̌v킪(-1)̒l̉ɗ邩A(b)~󂯎邩
   ̂ǂ炩܂ŎM޲Ăi[܂B~󂯎A0܂-1̂ǂ
   炩łȂ΁Aُ͈ł̂悤ɍ}܂(~MAdr
   ׸ނʂĂAνĂ[dɈُ}邱Ƃ͕s\ł)B̌v
   0̏ꍇAPEC֎~Ă邱Ƃ܂Bv킪-1̏ꍇA
   PECĂ邱Ƃ܂Bүނ͂̔Fŏ܂B

   ǂATWIINTL̂܂܂ɂĂ̂SCLLowێĂȂ߁A
   OүނĂ܂܂ŁAүނʂ̋@\KvƂ
   ܂B͕\ނsүނ̏I܂ŁA㑱޲Ăүނ
   ACK̐OFFɂ邱Ƃɂčs܂B

   ]āAsүނ̏SɏI܂ŁATWI_CmdFlagsϐ̒l
   'SMB_GotCmdData'ƓύXȂƂdvłB

   ̎dg݂͓drZȊԂɎ呕uǂݍ݂s悤ƂꍇɂL
   B̏ꍇA呕ȗ2޲āASMBus޲Ă͉܂B呕u
   ͂ɂĒ~𐶐邱ƂKvƂ܂B

*/

// ԋ@\̏
enum /*TWISR_State*/ {TW_IDLE=0, TW_Wait4Stop, TW_Wait4Cmd, TW_Wait4RW, TW_Wait4Data, TW_ReplyData, TW_MSLA_W, TW_MCMD_W, TW_MDATA_W };

unsigned char TWISR_state = TW_IDLE;	// ԕϐ


#pragma vector = TWI_vect
__interrupt void TWI_ISR(void)
{
	static unsigned char TWISR_CmdFeatures = 0;		// ߊ֘A@\׸
	unsigned char Status;
	unsigned char tmp;

	Status = TWSR & 0xF8;		// ͉荞݂nʂ܂B

	switch(TWISR_state)
	{
		default:
		case TW_IDLE:			// SLA_W܂RSTOPłȂꍇɈُ!
			if(TWS_SLA_W == Status)						// ޯĂ]uڽvɑ
			{
				if(TWI_CmdFlags == SMB_GotCmdData)
				{
					// ~𓾂܂TWEA*OFF*̂܂܂ɂ邱ƂɂSMBus呕u'Z'Lɂ܂B
					// SMBusdlɂĕKvƂ̂ŏ]uڽ֊ACK𑗂߁A
					// ꂪ''ł邱ƂɒӂĂB
					TWISR_state = TW_Wait4Stop;
					TWCR = (1<<TWINT) | (1<<TWEN) | (1<<TWIE);		// ACKċĂ͂Ȃ܂B
					return;
				}
				else
					TWISR_state = TW_Wait4Cmd;
			}
			else
			if(TWS_RSTOP == Status)		// ~AO̖߂̎c̉\
			{
				; // SĂ炭OKA܂B
			}
			else
			if(TWS_START == Status)						// JnޯđoA呕u쏈
			{
				TWDR = TW_MTxBuf[TW_MTxBufIndex++];
				TWISR_state = TW_MSLA_W;
			}
			else		// ُ̈
			{
				SMBvariables[SMBV_BattStatus][lobyte] |= SMBerr_UnknownError;
				TWI_CmdFlags = SMB_GenBusTimeout;		// ޽Ԑ
				TWCR = (1<<TWEA) | (1<<TWEN);			// 荞݋֎~ATWINT׸ނȂł!B
				TWISR_state = TW_IDLE;					// ԋ@\ؾ
				return;
			}
			TWCR = (1<<TWINT) | (1<<TWEA) | (1<<TWEN) | (1<<TWIE);		// ACKċȂ΂Ȃ܂B
			break;

		case TW_Wait4Stop:
			if(TWS_RSTOP == Status)						// ~AO̖߂̎c̉\
			{
				TWCR = (1<<TWINT) | (1<<TWEA) | (1<<TWEN) | (1<<TWIE);	// ACKċȂ΂Ȃ܂B
				TWISR_state = TW_IDLE;					// ԋ@\ؾ
			}
			else
				TWCR = (1<<TWINT) | (1<<TWEN) | (1<<TWIE);		// ACKċĂ͂Ȃ܂!B
			break;

		// ]uԂ̗

		case TW_Wait4Cmd:		// ڍsɖ޲ĂMƗ\z
			if(TWS_RCMD == Status)						// ▽޲ĂMƎv܂B
			{
				tmp = TWDR;
				if(tmp <= HIGHEST_SMB_CMD)				// ߂L͈?
				{
					CurrentCmd = tmp;					// ۑ
					tmp = SM_Cmd_Table[tmp][0];			// ߓ/@\׸ނߑ
					if(tmp & SMBslave)					// ߂]uɑ΂ėL?
					{	// LƎv閽
						TWISR_CmdFeatures = tmp;		// Wait4RWԂŎg@\׸ނۑ
						TWISR_state = TW_Wait4RW;		// ̏Ԃݒ
						TWCR = (1<<TWINT) | (1<<TWEA) | (1<<TWEN) | (1<<TWIE);		// ACK
						return;
					}
				}
			}
			// In all cases except those that 'return' (above), it's an error.
			SMBvariables[SMBV_BattStatus][lobyte] |= SMBerr_UnknownError;
			TWI_CmdFlags = SMB_GenBusTimeout;			// ޽Ԑ
			TWCR = (1<<TWEA) | (1<<TWEN);				// 荞݋֎~ATWINT׸ނȂł!B
			TWISR_state = TW_IDLE;						// ԋ@\ؾ
			return;
//			break;

		case TW_Wait4RW:		// M삩Aɕԓ𑗂邩܂B
			if(TWS_RDATA == Status)						// ݌^߁Aް󂯎邽߂̎MɏՕ
			{	// : OptionalMfgFunction5ASĂ̏ݖ߂2޲ĂƔCӑIPECłB
				// Pʏ̑S޲Ă͊ɏՕɒuÂɕKvƂȂAPECsƂł܂B
				TW_RxBuf[0] = TWAR & 0xFE;				// PECvZp̏]uڽ܂ݑSĂۑ
				TW_RxBuf[1] = CurrentCmd;				// Oɑꂽo߂i[
				TW_RxBuf[2] = TWDR;						// ̍ŏް ޲Ăi[
				TW_RxBufIndex = 3;						// ɏՂްi[邽߂̎wWƂRxBufIndexgp
				if(TWISR_CmdFeatures & SCWW)			// ꏑݖߌ^?
				{
					TW_RxBufCnt = 1;					// X1ް ޲Ă\zǍPEC̉\
				}
				else
				if(TWISR_CmdFeatures & SCWG)			// 򏑂ݖ? (OptionalMfgFunction5łȂ΂Ȃ܂B)
				{
					tmp = TWDR;
					if((tmp >= 1) && (tmp <= 32))
						TW_RxBufCnt = TWDR;
					else
					{
						SMBvariables[SMBV_BattStatus][lobyte] |= SMBerr_BadSize;
						TWI_CmdFlags = SMB_GenBusTimeout;	// ޽Ԑ
						TWCR = (1<<TWEA) | (1<<TWEN);       // 荞݋֎~ATWINT׸ނȂł!B
						TWISR_state = TW_IDLE;				// ԋ@\ؾ
						return;
					}
				}
				else		// ̖߂͌܂͌Q/̂ǂ܂!BǂݍݐpłB
				{
					SMBvariables[SMBV_BattStatus][lobyte] |= SMBerr_AccessDenied;
					TWI_CmdFlags = SMB_GenBusTimeout;	// Not a WRITE-type cmd, so ޽Ԑ
					TWCR = (1<<TWEA) | (1<<TWEN);		// 荞݋֎~ATWINT׸ނȂł!B
					TWISR_state = TW_IDLE;				// ԋ@\ؾ
					return;
				}
				TWISR_state = TW_Wait4Data;
				TWCR = (1<<TWINT) | (1<<TWEA) | (1<<TWEN) | (1<<TWIE);		// ACK
			}
			else
			if(TWS_REPEAT == Status)					// đJnɑÂɓǂݍݖߏȂ΂Ȃ܂B
			{	// ⒼOɑꂽCurrentCmd߂ĕԓްȂ΂Ȃ܂B
				if(TWISR_CmdFeatures & (SCRW | SCRG))	// 'ReadWord'܂'ReadGroup'̖ߌ^?
				{
					TWI_CmdFlags = SMB_SetUpReply;		// \ޕTWCR
					TWISR_state = TW_ReplyData;			// ̏Ԃֈړ
				}
				else
				{
					SMBvariables[SMBV_BattStatus][lobyte] |= SMBerr_UnknownError;
					TWI_CmdFlags = SMB_GenBusTimeout;	// ǂݍݑ߂ł͂ȂÂ޽Ԑ
					TWCR = (1<<TWEA) | (1<<TWEN);		// 荞݋֎~ATWINT׸ނȂł!B
					TWISR_state = TW_IDLE;				// ԋ@\ؾ
					return;
				}
				TWCR = (1<<TWEA) | (1<<TWEN);			// 荞݋֎~ATWINT׸ނȂł!B
				return;					
			}
			else		// ُ̈!
			{
				SMBvariables[SMBV_BattStatus][lobyte] |= SMBerr_UnknownError;
				TWI_CmdFlags = SMB_GenBusTimeout;		// ޽Ԑ
				TWCR = (1<<TWEA) | (1<<TWEN);			// 荞݋֎~ATWINT׸ނȂł!B
				TWISR_state = TW_IDLE;					// ԋ@\ؾ
				return;
			}
			break;

		case TW_Wait4Data:		// ]uM`
			if(TWS_RDATA == Status)						// ް ޲Ď󂯎
			{
				tmp = TWDR;
				if(--TW_RxBufCnt < -1)					// PEC޲Ă߂Ėް擾?
				{
					SMBvariables[SMBV_BattStatus][lobyte] |= SMBerr_BadSize;	// ްjƈُ퍇}
					TWI_CmdFlags = SMB_GenBusTimeout;	// ޽Ԑ
					TWCR = (1<<TWEA) | (1<<TWEN);		// 荞݋֎~ATWINT׸ނȂł!B
					TWISR_state = TW_IDLE;				// ԋ@\ؾ
					return;
				}
				TW_RxBuf[TW_RxBufIndex++] = TWDR;		// ޲Ċi[
			}

			else
			if(TWS_RSTOP == Status)						// ~擾AްMI
			{	// : ߂̒~𓾂ꍇA呕üُʒm̂x邽߁A
				//	   Pɂ̖߂𖳎܂B
				if((TW_RxBufCnt > 0) || (TW_RxBufCnt < -1))		// ߂~܂͑ް擾: ُ
				{
					SMBvariables[SMBV_BattStatus][lobyte] |= SMBerr_BadSize;	// ްj
				}
				else
				{
					if(0 == TW_RxBufCnt)
						UsePEC = 0;						// ߹Ăɑ΂PECȂ
					else
					if(-1 == TW_RxBufCnt)
						UsePEC = 1;						// PEC܂܂Ă܂B

					TW_RxBufCnt = TW_RxBufIndex;		// L޲ĐƂďݎwW̒lėp
					TW_RxBufIndex = 0;					// ߗpŎwW
					TWI_CmdFlags = SMB_GotCmdData;		// ₱̏\ނɒʒm
					// (TWI_CmdFlags=SMB_GotCmdData)TWI ISRZԂŉ邱ƂɒӂĂB
				}
				TWISR_state = TW_IDLE;					// SĂ̏ꍇŏԋ@\ؾ
			}

			else		// [Ɉُ̈!
			{
				SMBvariables[SMBV_BattStatus][lobyte] |= SMBerr_UnknownError;
				TWI_CmdFlags = SMB_GenBusTimeout;		// ݌^߂ł͂ȂÂ޽Ԑ
				TWCR = (1<<TWEA) | (1<<TWEN);			// 荞݋֎~ATWINT׸ނȂł!B
				TWISR_state = TW_IDLE;					// ԋ@\ؾ
				return;
			}

			TWCR = (1<<TWINT) | (1<<TWEA) | (1<<TWEN) | (1<<TWIE);	// ACK
			break;

		case TW_ReplyData:		// ]uM`
			// \ނ͍⑗鉞܂B
			// : TW_TxBufCnt**PEC޲Ă܂݂܂BۂɎ呕uPEC޲
			// ]ނۂmȂ̂ŁAUsePEC׸ނ̏ԂɊւ炸Aɂ
			// 𑗂낤Ƃ܂B呕u]܂ȂꍇAPEC޲Ăɏ
			// ̊ԂNAK𓾂ł傤BPEC޲Ă܂ޑSĂ𑗂ǂ
			// ACKԓ𓾂HȏꍇAPECoTWEAޯĂݒ肵Ȃ߁ATWI
			// Pʕ͂Ƃɂײ݂ŁA]āAُ픭}邱Ƃs\
			// B
			if((TWS_SLA_R == Status) || (TWS_RACK == Status))	// ԓްo
			{
				TWDR = TW_TxBuf[TW_TxBufIndex++];		// ްo
				if(--TW_TxBufCnt == 0)					// PEC܂݁AɏՕ?
					TWCR = (1<<TWINT) | (1<<TWEN) | (1<<TWIE);				// ͂ÂTWEAݒ肵܂B
				else
					TWCR = (1<<TWINT) | (1<<TWEA) | (1<<TWEN) | (1<<TWIE);	// ÂTWEALɂ܂B
			}
			else
			if(TWS_RNAK == Status)						// ̐A܂ُ͈Ƃē邩܂B
			{
				if(TW_TxBufCnt == 1)					// ُł͂ȂB呕uPEC]܂ȂAUsePEC׸ނ
				{
					TW_TxBufCnt = 0;					// ɏՕ
					UsePEC = 0;
				}
				else
				if(TW_TxBufCnt == 0)					// ُł͂ȂA呕uPEC(Ƃ̎擾)]ށAUsePECLݒ
					UsePEC = 1;
				else	// ُ̈픭ANAK擾!
				{ // : TWIPʕ͵ײ݁Âɂُ̈νĒʒmł܂!B
					SMBvariables[SMBV_BattStatus][lobyte] |= SMBerr_UnknownError;	// ō}
				}
				TWISR_state = TW_IDLE;					// SĂ̏ꍇŁAނ֍s܂B
				TWCR = (1<<TWINT) | (1<<TWEA) | (1<<TWEN) | (1<<TWIE);
			}
			else
//			if(TWS_FINAL == Status)						// ُ: ACK𓾂܂AXȂް܂!B
			{	// TWIPʕ"ڽw肳ĂȂ]u"̂߁A̒PʏɎ呕u
				// ُ}邱ƂłAُԂLɂ܂B
				SMBvariables[SMBV_BattStatus][lobyte] |= SMBerr_BadSize;
				TWISR_state = TW_IDLE;					//ԋ@\ؾ
				TWCR = (1<<TWINT) | (1<<TWEA) | (1<<TWEN) | (1<<TWIE);
			}
			break;

		// 呕uԂ̗

		case TW_MSLA_W:			// 呕uŒPɏ]uڽ𑗏o悤Ƃ܂B
			if(TWS_WRITE_ACK == Status)					// ]SLA+WACKԓ𓾂܂B
			{
				TWDR = TW_MTxBuf[TW_MTxBufIndex++];		// ߑo
				TWISR_state = TW_MCMD_W;
				TWCR = (1<<TWINT) | (1<<TWEA) | (1<<TWEN) | (1<<TWIE);
			}
			else	// ̉\zȂA܂ُ͈̌
			{ // Ƃɂ10bł炪đoȂ߁AołȂүނPɍ폜
				TWCR = (1<<TWINT) | (1<<TWEA) | (1<<TWSTO) | (1<<TWEN) | (1<<TWIE);
				TWISR_state = TW_IDLE;	// ԋ@\ؾ
				TW_MTxBufCnt = 0;
				TW_MTxBufIndex = 0;
				TXmsgDelete;			// MɏՕ璚xүނ폜
				SMLOCK = 0;
			}
			break;

		case TW_MCMD_W:			// PɎ呕u޲Ă܂ް ޲Ă𑗏o
			if(TWS_TXDATA_ACK == Status)					// ްACK擾
			{
				if(TW_MTxBufCnt > TW_MTxBufIndex)
				{
					TWDR = TW_MTxBuf[TW_MTxBufIndex++];		// ް ޲đo
					TWISR_state = TW_MCMD_W;
					TWCR = (1<<TWINT) | (1<<TWEA) | (1<<TWEN) | (1<<TWIE);
				}
				else	// ɏՕ̑SĂ𑗏oÂɍ~𑗏o
				{
					TWCR = (1<<TWINT) | (1<<TWEA) | (1<<TWSTO) | (1<<TWEN) | (1<<TWIE);
					TWISR_state = TW_IDLE;
					TW_MTxBufCnt = 0;
					TW_MTxBufIndex = 0;
					TXmsgDelete;		// MɏՕ璚xүނ폜
					SMLOCK = 0;
				}
			}
			else	// \Ȃ܂ُ͈ȉ
			{
				TWCR = (1<<TWINT) | (1<<TWEA) | (1<<TWSTO) | (1<<TWEN) | (1<<TWIE);
				TWISR_state = TW_IDLE;
				TW_MTxBufCnt = 0;
				TW_MTxBufIndex = 0;
				TXmsgDelete;			// MɏՕ璚xүނ폜
				SMLOCK = 0;
			}
			break;

	} // switch(TWISR_state)I
}


/* *************************************************************************
 *
 *   \SMBus߉ߕ
 *
 ************************************************************************* */

// үނɏՕȂA呕un߂悤Ƃ܂B
void SMB_Master(void)
{
	unsigned char * ptr;
	unsigned char PEC;

	if(!(TW_MTxBufCnt))		// Lүނ邩?
	{
		if(TXmsgEmpty)
			return;

		ptr = TXmsg[TXmsgTail];
		if(UsePEC)
		{
			PEC = FastCRC( 0,  TW_MTxBuf[0] = *ptr++);
			PEC = FastCRC(PEC, TW_MTxBuf[1] = *ptr++);
			PEC = FastCRC(PEC, TW_MTxBuf[2] = *ptr++);
			PEC = FastCRC(PEC, TW_MTxBuf[3] = *ptr);
			TW_MTxBuf[4] = PEC;
			TW_MTxBufCnt = 5;
		}
		else
		{
			TW_MTxBuf[0] = *ptr++;
			TW_MTxBuf[1] = *ptr++;
			TW_MTxBuf[2] = *ptr++;
			TW_MTxBuf[3] = *ptr;
			TW_MTxBufCnt = 4;
		}

		TW_MTxBufIndex = 0;
		SMLOCK = 0;
		TEST50US = 0;
	}

	if(SMLOCK)				// LȂAɑMJn
		return;

	if(TEST50US)			// œ鎞ɗLȂAŒ50s҂޽Ȃɑ
	{
		__disable_interrupt();
		if((PINA & (1<<6)) && (TWISR_state == TW_IDLE))
		{
			SMLOCK = 1;
			TWBR = 12;						// 12100kHz𐶂܂B
			TWCR = ((1<<TWINT) | (1<<TWSTA) | (1<<TWEN) | (1<<TWIE));	// Jn𑗏o
			PCICR = 0;						// PCINT0/PA6֎~
			TEST50US = 0;					// ׸މÂPCINT6͍ĎsȂ΂ȂȂꍇɍċ܂B
		}
		__enable_interrupt();
		return;
	}

	if((PINA & (1<<6)) && (TWISR_state == TW_IDLE))
	{
		TEST50US = 1;
		// PA6pݕω荞݂APA6PICNT6
		PCIFR = (1<<PCIF1) | (1<<PCIF0);	// ݂ǂ׸ނ
		PCMSK0 = (1<<6);					// PA6ݕω荞
		PCICR = (1<<PCIE0);					// PCINT0Q
	}
}

void Check50uS(void)
{
	if(TEST50US)
		SMB_Master();
}

void SMB_CmdInterpreter(void)
{
	unsigned char temp;

	if(SMB_GenBusTimeout == TWI_CmdFlags)	// ISRُԂo
	{
		TWI_CmdFlags = 0;					// ɗ׸ނ
		// 26msvJnBIAv폈TWIӋ@\ď
		SetGenericTimer(SMBfaultTimer, 26);
		return;
	}
	else
	if(SMB_SetUpReply == TWI_CmdFlags)		// 'ǂݍ'߂
	{
		TWI_CmdFlags = 0;						// ɗ׸ނ
		TW_TxBufIndex = 0;						// 
		TW_TxBufCnt = 0;						// 
		if(0 != SMB_ReadCmd[CurrentCmd]())		// ߌAُ킠??
		{
			SMBvariables[SMBV_BattStatus][lobyte] |= SMBerr_UnsuptdCommand;
			SetGenericTimer(SMBfaultTimer, 26);		// ޽Ԉُ퐶
			TW_TxBufIndex = 0;		  				// Ô߁AɏՕ|
			TW_TxBufCnt = 0;
			return;
		}
		else		// ⌳̗v܂߂*S*PʏpPEC𐶐!
		{
			// (TW_TxBufIndex == 0)(TW_TxBufCtr == PEC܂܂Ȃް޲Đ)Ɖ
			temp = FastCRC(0, (TWAR & 0xFE));	// SLA+Wڽgp
			temp = FastCRC(temp, CurrentCmd);
			temp = FastCRC(temp, (TWAR | 1));	// SLA+Rڽgp

			do {temp = FastCRC(temp, TW_TxBuf[TW_TxBufIndex++]);}
			while(TW_TxBufIndex != TW_TxBufCnt);

			TW_TxBuf[TW_TxBufIndex] = temp;		// ŌCRCl(PEC)ǉ
			TW_TxBufCnt++;						// PECp޲Čv𑝉
			TW_TxBufIndex = 0;					// ɏՕʒuwqؾ
			TWCR = (1<<TWINT) | (1<<TWEA) | (1<<TWEN) | (1<<TWIE);	// ~ꏊTWIp
		}
		return;
	}
	else
	if(SMB_GotCmdData == TWI_CmdFlags)		// M+ް
	{
		// : 2005N617ȍ~BTWI_CmdFlags͂үނ̏SɏI
		//	   ܂ŉׂł͂ȂAȂ΁ATWI ISRMɏՕ
		//	   ㏑AׂZł̉܂BɈڍsƁA
		//	   TWISɍċÂTWIʰ޳ ڼ޽̂ǂɂĂ͂
		//	   炸AȂ΁AjN܂B-rgf

		if(UsePEC)			// M߹ĂCRC
		{
			temp = 0;				// 쐬CRClƂĂgp

			do { temp = FastCRC(temp, TW_RxBuf[TW_RxBufIndex++]); }
			while(TW_RxBufCnt != TW_RxBufIndex);

			if(temp)		// SĂOKȂACRCʂ0łׂłB
			{
				SMBvariables[SMBV_BattStatus][lobyte] |= SMBerr_UnknownError;

				// ޽Ԉُ𐶐邽߂26msvJn
				SetGenericTimer(SMBfaultTimer, 26);
				TWI_CmdFlags = 0;	// ɗ׸ނ
				return;
			}
		}

		// Mүނ͍▽ߏĂяo𐳓Ƃ̂ɏ[LłB

		// drɑ̂ɉ򓮍gʏSMBus߂̂ǂȂA
		// ̂TW_RxBuf[2]͌޲Čvł͂ȂAްȂƂɒӂĂ
		// BOptionalMfgFunction(5)ɂāAAg閽ߋ@\g[2]
		// ޲Čvŕψ=[3]Ŏۂްn܂邱ƂmĂ܂B
		TW_RxBufIndex = 2;			// Mް̐擪޲Ăւ̈ʒuwq

		if(0 != SMB_WriteCmd[CurrentCmd]())		// ߌɈُ킠??
		{
			TW_RxBufIndex = 0;		// Ô߁AɏՕ|
			TW_RxBufCnt = 0;

			// ޽Ԉُ𐶐邽߂26msvJn
			SetGenericTimer(SMBfaultTimer, 26);
			TWI_CmdFlags = 0;		// ɗ׸ނ
			return;
		}
		// ̎_őSĂ肭悤łB
		TWI_CmdFlags = 0;			// ɗ׸ނ
		return;
	}
}

// ̊֐(Ō̖߂ŉsƂ呕uɍ邽߂)޽
// Ԉُ̈ӂɐASMBusTWI_ISRԋ@\ʏɖ߂܂B
void SMB_RestoreBus(void)
{
	TWCR = 0;					// Ӌ@\~
	TWISR_state = TW_IDLE;		// ԋ@\
	TWAR = BATTERY_ADDR;			
	TWCR = (1<<TWINT) | (1<<TWEA) | (1<<TWEN) | (1<<TWIE);	// | (1<<TWSTO) ċ

	// ǍʂƂĈ޽ُ𐶐Ȃ悤ɒӂȂ΂Ȃ炸A
	// Ȃ΁AُԂғɖ߂鎞Ɍ鉽ɂ悤ł͂Ȃꍇɕ
	// ޽Ԃ𐶐邱ƂɂĖJԂɊׂ邱ƂɒӂĂ
	// B
}


/* *************************************************************************
 *
 *   SMBusǂݍ݌^ߗpʏ
 *
 *   ̊֐̂ǂ炩Ă΂ƁASMBus͌Ă񂾊֐̌ʂ҂~Ԃ
 *   B̂ǂꂩ̏Ɉُ킪oꂽꍇA肪Ƃ呕u
 *   ɒʒm邽߂޽Ԉُ킪Ȃ΂Ȃ܂BłȂA
 *   SĂOKȂA呕u֑M邽߁A呕uɂėvĂް
 *   TW_TxBufɏՕɏȂ΂Ȃ܂B̊֐͂ꂪI
 *   SMB_CmdInterpreter()֐ŏ邽߁APEClvZKv܂B
 *
 *   ̑SĂ̊֐ɑ΂L߂l͎̂ƂłB:
 *      0: ُ팟oA޽Ԉُ𐶐Ȃ΂Ȃ܂B
 *      1: vꂽްTW_TxBufɏՕɑ݂܂B
 *
 ************************************************************************* */

void FillResponseInt(unsigned int info)
{
	TW_TxBuf[0] = (unsigned char) info;
	TW_TxBuf[1] = (unsigned char) (info >> 8);

	TW_TxBufIndex = 0;
	TW_TxBufCnt = 2;
}


void FillResponseStr(char __flash * source)
{
	unsigned char * dest = TW_TxBuf;
	unsigned char ctr = 0;

	for(;;)
	{
		if(*dest++ = *source++)
			ctr++;
		else
			break;
	}

	TW_TxBufIndex = 0;
	TW_TxBufCnt = ctr;
}

/* ************************************************** */

unsigned char SMBR_MfrAccess(void)		// ߔԍ0
{
	FillResponseInt(SMBvar_int[SMBV_MfrAccess]);
	return 0;
}

unsigned char SMBR_RemCapAlm(void)		// ߔԍ1
{
	FillResponseInt(SMBvar_int[SMBV_RemCapAlm]);
	return 0;
}

unsigned char SMBR_RemTimeAlm(void)		// ߔԍ2
{
	FillResponseInt(SMBvar_int[SMBV_RemTimeAlm]);
	return 0;
}

unsigned char SMBR_BattMode(void)		// ߔԍ3
{
	FillResponseInt(SMBvar_int[SMBV_BattMode]);
	return 0;
}

unsigned char SMBR_AtRate(void)			// ߔԍ4
{
	FillResponseInt(SMBvar_int[SMBV_AtRate]);
	return 0;
}

unsigned char SMBR_AtRateTTF(void)		// ߔԍ5
{
	unsigned int temp = AtRateTTF();
	SMBvar_int[SMBV_AtRateTTF] = temp;	// ޯޖړIpAʂ̋Ǐۑ
	FillResponseInt(temp);
	return 0;
}

unsigned char SMBR_AtRateTTE(void)		// ߔԍ6
{
	unsigned int temp = AtRateTTE();
	SMBvar_int[SMBV_AtRateTTE] = temp;
	FillResponseInt(temp);
	return 0;
}

unsigned char SMBR_AtRateOK(void)		// ߔԍ7
{
	unsigned int temp = AtRateOK();
	SMBvar_int[SMBV_AtRateOK] = temp;
	FillResponseInt(temp);
	return 0;
}

unsigned char SMBR_Temperature(void)	// ߔԍ8
{
	unsigned int temp = GetTemperature();
	SMBvar_int[SMBV_Temperature] = temp;
	FillResponseInt(temp);
	return 0;
}

unsigned char SMBR_Voltage(void)		// ߔԍ9
{
	unsigned int volt = GetVoltage();
	SMBvar_int[SMBV_Voltage] = volt;
	FillResponseInt(volt);
	return 0;
}

unsigned char SMBR_Current(void)		// ߔԍ10
{
	signed int current = Current1Sec();

	SMBvar_int[SMBV_Current] = (unsigned int) current;
	FillResponseInt((unsigned int) current);
	return 0;
}

unsigned char SMBR_AvgCurrent(void)		// ߔԍ11
{
	signed int current = CCarray_Average();

	SMBvar_int[SMBV_AvgCurrent] = (unsigned int) current;
	FillResponseInt((unsigned int) current);
	return 0;
}

unsigned char SMBR_MaxError(void)		// ߔԍ12
{
	FillResponseInt(SMBvar_int[SMBV_MaxError] = 0);
	return 0;
}

unsigned char SMBR_RelSOC(void)			// ߔԍ13
{
	unsigned int temp = RelativeSOC();

	SMBvar_int[SMBV_RelSOC] = temp;
	FillResponseInt(temp);
	return 0;
}

unsigned char SMBR_AbsSOC(void)			// ߔԍ14
{
	unsigned int temp = AbsoluteSOC();

	SMBvar_int[SMBV_AbsSOC] = temp;
	FillResponseInt(temp);
	return 0;
}

unsigned char SMBR_RemCap(void)			// ߔԍ15
{
	unsigned int cap = RemainingCap();

	FillResponseInt(cap);
	SMBvar_int[SMBV_RemCap] = cap;
	return 0;
}

unsigned char SMBR_FullChgCap(void)		// ߔԍ16
{
	unsigned int cap = FullChgCap();

	FillResponseInt(cap);
	SMBvar_int[SMBV_FullChgCap] = cap;
	return 0;
}

unsigned char SMBR_RunTTE(void)			// ߔԍ17
{
	unsigned int temp = TimeToEmpty(0);

	FillResponseInt(temp);
	SMBvar_int[SMBV_RunTTE] = temp;
	return 0;
}

unsigned char SMBR_AvgTTE(void)			// ߔԍ18
{
	unsigned int temp = TimeToEmpty(1);

	FillResponseInt(temp);
	SMBvar_int[SMBV_AvgTTE] = temp;
	return 0;
}

unsigned char SMBR_AvgTTF(void)			// ߔԍ19
{
	unsigned int temp = AvgTimeToFull();

	FillResponseInt(temp);
	SMBvar_int[SMBV_AvgTTF] = temp;
	return 0;
}

/* ********************************************** */

// 2үނ͏[d܂νĂ̂ǂ炩瑗܂B
unsigned char SMBR_ChgCurrent(void)		// ߔԍ20
{
	SMBvariables[SMBV_BattStatus][lobyte] &= 0xF0;		// ̖߂OK̂߁Asbdat110, 4.3.2ɑ΂ُޯĂ
	FillResponseInt(SMBvar_int[SMBV_ChgCurrent]);
	return 0;
}

unsigned char SMBR_ChgVoltage(void)		// ߔԍ21
{
	SMBvariables[SMBV_BattStatus][lobyte] &= 0xF0;		// ̖߂OK̂߁Asbdat110, 4.3.2ɑ΂ُޯĂ
	FillResponseInt(SMBvar_int[SMBV_ChgVoltage]);
	return 0;
}

/* ********************************************** */

unsigned char SMBR_BattStatus(void)		// ߔԍ22
{
	FillResponseInt(SMBvar_int[SMBV_BattStatus]);
	SMBvariables[SMBV_BattStatus][lobyte] &= 0xF0;
	return 0;
}

unsigned char SMBR_CycleCount(void)		// ߔԍ23
{
	FillResponseInt(SMBvar_int[SMBV_CycleCount]);
	return 0;
}

unsigned char SMBR_DesignCap(void)		// ߔԍ24
{
	unsigned long temp;

	if(SMBvariables[SMBV_BattMode][hibyte] & CAPACITY_MODE)		// vZłmWgp
		temp = PACK_DESIGNCAPMW;
	else
		temp = PACK_DESIGNCAPC5;

	FillResponseInt(temp);
	SMBvar_int[SMBV_DesignCap] = (unsigned int)temp;
	return 0;
}

unsigned char SMBR_DesignVolt(void)		// ߔԍ25
{
	FillResponseInt(PACK_NOMINALV);
	SMBvar_int[SMBV_DesignVolt] = PACK_NOMINALV;
	return 0;
}

unsigned char SMBR_SpecInfo(void)		// ߔԍ26
{
	FillResponseInt(SMBvar_int[SMBV_SpecInfo]);		//! \todo ̒l͏ɂĒ萔ƂĖ܂B
	return 0;
}

unsigned char SMBR_MfrDate(void)		// ߔԍ27
{
	FillResponseInt(SMBvar_int[SMBV_MfrDate]);		//! \todo ̒l͏ɂĒ萔ƂĖ܂B
	return 0;
}

unsigned char SMBR_SerialNo(void)		// ߔԍ28
{
	FillResponseInt(SMBvar_int[SMBV_SerialNo]);		//! \todo ̒l͏ɂĒ萔ƂĖ܂B
	return 0;
}

unsigned char SMBR_MfrName(void)		// ߔԍ32
{
	FillResponseStr(str_MfrName);			//! \todo KvȎɕύXBsmbus.hŒ`__flash char
	return 0;
}

unsigned char SMBR_DeviceName(void)		// ߔԍ33
{
	FillResponseStr(str_DeviceName);		//! \todo KvȎɕύXBsmbus.hŒ`__flash char
	return 0;
}

unsigned char SMBR_DeviceChem(void)		// ߔԍ34
{
	FillResponseStr(str_DeviceChem);		//! \todo KvȎɕύXBsmbus.hŒ`__flash char
	return 0;
}

unsigned char SMBR_MfrData(void)		// ߔԍ35
{
	FillResponseStr(str_MfrData);			//! \todo KvȎɕύXBsmbus.hŒ`__flash char
	return 0;
}

unsigned char SMBR_Opt5(void)			// ߔԍ0x2F
{
	FillResponseInt(12345);					//! \todo ̒l͂Œ萔ƂĒ`܂B
	return 0;
//	return SMBerr_ReservedCommand;
}

unsigned char SMBR_Opt4(void)			// ߔԍ0x3C(ZƂĈ܂B)
{
	FillResponseInt( calibration_state );	// MɏՕ̌
	return 0;								// "OKAMް"Ԃ܂B
}

unsigned char SMBR_Opt3(void)			// ߔԍ0x3D
{

	return SMBerr_ReservedCommand;			// gp
}

unsigned char SMBR_Opt2(void)			// ߔԍ0x3E
{

	return SMBerr_ReservedCommand;			// gp
}

unsigned char SMBR_Opt1(void)			// ߔԍ0x3F
{

	return SMBerr_ReservedCommand;			// gp
}

unsigned char SMBR_invalid(void)		// ُ킪ɕ߂炦ꂽȂAꂪĎsׂł͂܂B
{
	return SMBerr_UnsuptdCommand;
}

//typedef unsigned char (*ptr2funcUC_V)(void);

// MSMBus޲ĂŎwEꂽ@\ւ̈ʒuwq̕\
ptr2funcUC_V SMB_ReadCmd[HIGHEST_SMB_CMD+1] =
{
	SMBR_MfrAccess,		//   0
	SMBR_RemCapAlm,		//   1
	SMBR_RemTimeAlm,	//   2
	SMBR_BattMode,		//   3
	SMBR_AtRate,		//   4
	SMBR_AtRateTTF,		//   5
	SMBR_AtRateTTE,		//   6
	SMBR_AtRateOK,		//   7
	SMBR_Temperature,	//   8
	SMBR_Voltage,		//   9
	SMBR_Current,		//  10
	SMBR_AvgCurrent,	//  11
	SMBR_MaxError,		//  12
	SMBR_RelSOC,		//  13
	SMBR_AbsSOC,		//  14
	SMBR_RemCap,		//  15
	SMBR_FullChgCap,	//  16
	SMBR_RunTTE,		//  17
	SMBR_AvgTTE,		//  18
	SMBR_AvgTTF,		//  19
	SMBR_ChgCurrent,	//  20
	SMBR_ChgVoltage,	//  21
	SMBR_BattStatus,	//  22
	SMBR_CycleCount,	//  23
	SMBR_DesignCap,		//  24
	SMBR_DesignVolt,	//  25
	SMBR_SpecInfo,		//  26
	SMBR_MfrDate,		//  27
	SMBR_SerialNo,		//  28
	SMBR_invalid,		// (29)
	SMBR_invalid,		// (30)
	SMBR_invalid,		// (31)
	SMBR_MfrName,		//  32
	SMBR_DeviceName,	//  33
	SMBR_DeviceChem,	//  34
	SMBR_MfrData,		//  35
	SMBR_invalid,		// (36)
	SMBR_invalid,		// (37)
	SMBR_invalid,		// (38)
	SMBR_invalid,		// (39)
	SMBR_invalid,		// (40)
	SMBR_invalid,		// (41)
	SMBR_invalid,		// (42)
	SMBR_invalid,		// (43)
	SMBR_invalid,		// (44)
	SMBR_invalid,		// (45)
	SMBR_invalid,		// (46)
	SMBR_Opt5,			//  47  0x2F
	SMBR_invalid,		// (48)
	SMBR_invalid,		// (49)
	SMBR_invalid,		// (50)
	SMBR_invalid,		// (51)
	SMBR_invalid,		// (52)
	SMBR_invalid,		// (53)
	SMBR_invalid,		// (54)
	SMBR_invalid,		// (55)
	SMBR_invalid,		// (56)
	SMBR_invalid,		// (57)
	SMBR_invalid,		// (58)
	SMBR_invalid,		// (59)
	SMBR_Opt4,			//  60  0x3C
	SMBR_Opt3,			//  61  0x3D
	SMBR_Opt2,			//  62  0x3E
	SMBR_Opt1			//  63  0x3F
};


/* *************************************************************************
 *
 *   SMBus݌^ߌʏ
 *
 ************************************************************************* */


unsigned char SMBW_MfrAccess(void)		// ߔԍ0
{
	unsigned char temp = TW_RxBuf[TW_RxBufIndex++];

	SMBvar_int[SMBV_MfrAccess] = temp | (TW_RxBuf[TW_RxBufIndex]<<8);
	SMBvariables[SMBV_BattStatus][lobyte] &= 0xF0;		// ̖߂OK̂߁Asbdat110, 4.3.2ɑ΂ĈُޯĂ
	return 0;
}

unsigned char SMBW_RemCapAlm(void)		// ߔԍ1
{
	unsigned char temp = TW_RxBuf[TW_RxBufIndex++];

	SMBvar_int[SMBV_RemCapAlm] = temp | (TW_RxBuf[TW_RxBufIndex]<<8);
	SMBvariables[SMBV_BattStatus][lobyte] &= 0xF0;		// ̖߂OK̂߁Asbdat110, 4.3.2ɑ΂ĈُޯĂ
	return 0;
}

unsigned char SMBW_RemTimeAlm(void)		// ߔԍ2
{
	unsigned char temp = TW_RxBuf[TW_RxBufIndex++];

	SMBvar_int[SMBV_RemTimeAlm] = temp | (TW_RxBuf[TW_RxBufIndex]<<8);
	SMBvariables[SMBV_BattStatus][lobyte] &= 0xF0;		// ̖߂OK̂߁Asbdat110, 4.3.2ɑ΂ĈُޯĂ
	return 0;
}

unsigned char SMBW_BattMode(void)		// ߔԍ3
{
	unsigned char tempH = TW_RxBuf[TW_RxBufIndex+1];
	unsigned char tempL;

	tempL = SMBvariables[SMBV_BattMode][lobyte] & 0xF0;

	if(tempH & 0x1C)
		return SMBerr_AccessDenied;				// \񂳂ꂽޯĂւ݂̏悤Ƃ܂B

	if(~(tempL & INTERNAL_CHARGE_CONTROLLER))
	{
		tempH &= ~CHARGE_CONTROLLER_ENABLED;	// @\s݁AONɂȂłB
	}

	if(tempH & PRIMARY_BATTERY)
	{
		; // ׸ނŗՂމνĂ܂B;܂B
	}

	if(tempH & ALARM_MODE)
		SetAlarmMode;							// 60bԂ̌xүޑo֎~

	if(tempH & CHARGER_MODE)
	{
		; // [dɎ呕u[dd/dүޑoƂνĂɋ܂B
	}

	if(tempH & CAPACITY_MODE)
	{
		; // νĂ(mAh10mWnŕ񍐂)ޯĂ̐Ȃ΂Ȃ܂B
	}

	SMBvar_int[SMBV_BattMode] = tempL | (tempH<<8);		// ύXꂽޯĂ

	return 0;
}

unsigned char SMBW_AtRate(void)			// ߔԍ4
{
	unsigned char temp = TW_RxBuf[TW_RxBufIndex++];

	SMBvar_int[SMBV_AtRate] = temp | (TW_RxBuf[TW_RxBufIndex++]<<8);
	SMBvariables[SMBV_BattStatus][lobyte] &= 0xF0;		// ̖߂OK̂߁Asbdat110, 4.3.2ɑ΂ĈُޯĂ
	return 0;
}

unsigned char SMBW_Opt5(void)			// ߔԍ0x2F
{
	__disable_interrupt();
	MCUSR = 0x1F;							// ް۰ ނɔԑOɑSؾČ
//	__watchdog_reset;

	asm("jmp 0x9000");						// ޲ ڽ

//	__watchdog_reset;						// ޯ ؾ
	return(1);								// ׂ߲̌x邽߁AēBׂł͂܂B

//	return SMBerr_ReservedCommand;			// <-- returns̏ꍇɺׂ߲x𐶐
}

unsigned char SMBW_Opt4(void)			// ߔԍ0x3C
{
	calibration_state_req = TW_RxBuf[TW_RxBufIndex++];
	calibration_state_req |= (unsigned int)TW_RxBuf[TW_RxBufIndex++] << 8;	// vڍׂۑ
	SetCalibRequest;						// JԂZJn悤Ɋ׸ނݒ
	return 0;								// OKԂ܂B
}

unsigned char SMBW_Opt3(void)			// ߔԍ0x3D
{
	return SMBerr_ReservedCommand;
}

unsigned char SMBW_Opt2(void)			// ߔԍ0x3E
{
	return SMBerr_ReservedCommand;
}

unsigned char SMBW_Opt1(void)			// ߔԍ0x3F
{
	return SMBerr_ReservedCommand;
}

unsigned char SMBW_Invalid(void)		// ُ킪ɕ߂炦ꂽȂAꂪĎsׂł͂܂B
{
	return SMBerr_AccessDenied;
}

// MSMBus޲ĂŎwEꂽ@\ւ̈ʒuwq̕\
ptr2funcUC_V SMB_WriteCmd[HIGHEST_SMB_CMD+1] =
{
	SMBW_MfrAccess,		//   0
	SMBW_RemCapAlm,		//   1
	SMBW_RemTimeAlm,	//   2
	SMBW_BattMode,		//   3
	SMBW_AtRate,		//   4
	SMBW_Invalid,		//  (5)
	SMBW_Invalid,		//  (6)
	SMBW_Invalid,		//  (7)
	SMBW_Invalid,		//  (8)
	SMBW_Invalid,		//  (9)
	SMBW_Invalid,		// (10)
	SMBW_Invalid,		// (11)
	SMBW_Invalid,		// (12)
	SMBW_Invalid,		// (13)
	SMBW_Invalid,		// (14)
	SMBW_Invalid,		//  15  0x0F

	SMBW_Invalid,		// (16)
	SMBW_Invalid,		// (17)
	SMBW_Invalid,		// (18)
	SMBW_Invalid,		// (19)
	SMBW_Invalid,		// (20)
	SMBW_Invalid,		// (21)
	SMBW_Invalid,		// (22)
	SMBW_Invalid,		// (23)
	SMBW_Invalid,		// (24)
	SMBW_Invalid,		// (25)
	SMBW_Invalid,		// (26)
	SMBW_Invalid,		// (27)
	SMBW_Invalid,		// (28)
	SMBW_Invalid,		// (29)
	SMBW_Invalid,		// (30)
	SMBW_Invalid,		//  31  0x1F

	SMBW_Invalid,		// (32)
	SMBW_Invalid,		// (33)
	SMBW_Invalid,		// (34)
	SMBW_Invalid,		// (35)
	SMBW_Invalid,		// (36)
	SMBW_Invalid,		// (37)
	SMBW_Invalid,		// (38)
	SMBW_Invalid,		// (39)
	SMBW_Invalid,		// (40)
	SMBW_Invalid,		// (41)
	SMBW_Invalid,		// (42)
	SMBW_Invalid,		// (43)
	SMBW_Invalid,		// (44)
	SMBW_Invalid,		// (45)
	SMBW_Invalid,		// (46)
	SMBW_Opt5,			//  47  0x2F

	SMBW_Invalid,		// (48)
	SMBW_Invalid,		// (49)
	SMBW_Invalid,		// (50)
	SMBW_Invalid,		// (51)
	SMBW_Invalid,		// (52)
	SMBW_Invalid,		// (53)
	SMBW_Invalid,		// (54)
	SMBW_Invalid,		// (55)
	SMBW_Invalid,		// (56)
	SMBW_Invalid,		// (57)
	SMBW_Invalid,		// (58)
	SMBW_Invalid,		// (59)
	SMBW_Opt4,			//  60  0x3C
	SMBW_Opt3,			//  61  0x3D
	SMBW_Opt2,			//  62  0x3E
	SMBW_Opt1			//  63  0x3F
};


/* *************************************************************************
 *
 *   SMBusʐMpհèè
 *
 ************************************************************************* */

__flash unsigned char crctable[16] =  {0,0x07,0x0E,0x90, 0x1c,0x1b,0x12,0x15, 0x38,0x3F,0x36,0x31, 0x24,0x23,0x2A,0x2D};
__flash unsigned char crctable2[16] = {0,0x70,0xE0,0x90, 0xC1,0xB1,0x21,0x51, 0x83,0xF3,0x63,0x13, 0x42,0x32,0xA2,0xD2};

unsigned char FastCRC(unsigned char LastCRC, unsigned char newbyte)
{
	unsigned char index;

	index = newbyte;
	index ^= LastCRC;
	index >>= 4;
	LastCRC &= 0x0F;
	LastCRC ^= crctable2[index];

	index = LastCRC;
	index ^= newbyte;
	index &= 0x0F;
	LastCRC &= 0xF0;
	LastCRC ^= crctable[index];

	return(LastCRC);
}

/*  ̔łcrctable2[]KvƂ܂񂪁AޯĈړKvƂ܂B
unsigned char SlowerCRC(unsigned char LastCRC, unsigned char newbyte)
{
	unsigned char index;

	index = newbyte;
	index ^= LastCRC;
	index >>= 4;
	LastCRC <<= 4;
	LastCRC ^= crctable[index];

	index = LastCRC >> 4;
	index ^= newbyte;
	index &= 0x0F;
	LastCRC <<= 4;
	LastCRC ^= crctable[index];

	return(LastCRC);
} */

//! \todo SMBϐւ̌ŒlނERPROM̊ݒ肷悤ɕύX邱Ƃł܂B
// ͒ʓdł̊ݒ肵܂B
void InitSMBvariables(void)
{
	SMBvar_int[SMBV_MfrAccess  ] = 0x4060;						// ATmeag406pLqA0
	SMBvar_int[SMBV_RemCapAlm  ] = (PACK_DESIGNCAPTYP / 10);	// sbdat110, 4.4.1
	SMBvar_int[SMBV_RemTimeAlm ] = 0x000A;						// sbdat110, 4.4.1
	SMBvar_int[SMBV_BattMode   ] = 0x0000;	//
	SMBvar_int[SMBV_AtRate     ] = 0x0000;	//

/* For testing with no calcs
	SMBvar_int[SMBV_AtRateTTF  ] = 0x0000;	//
	SMBvar_int[SMBV_AtRateTTE  ] = 0x0000;	//
	SMBvar_int[SMBV_AtRateOK   ] = 0x0000;	//

	SMBvar_int[SMBV_Temperature] = 0x0000;	//
	SMBvar_int[SMBV_Voltage    ] = 0x0000;	//
	SMBvar_int[SMBV_Current    ] = 0x0000;	//
	SMBvar_int[SMBV_AvgCurrent ] = 0x0000;	//
	SMBvar_int[SMBV_MaxError   ] = 0x0000;	//
	SMBvar_int[SMBV_RelSOC     ] = 0x0000;	//
	SMBvar_int[SMBV_AbsSOC     ] = 0x0000;	//
	SMBvar_int[SMBV_RemCap     ] = 0x0000;	//

	SMBvar_int[SMBV_FullChgCap ] = 0x0000;	//
	SMBvar_int[SMBV_RunTTE     ] = 0x0000;	//
	SMBvar_int[SMBV_AvgTTE     ] = 0x0000;	//
	SMBvar_int[SMBV_AvgTTF     ] = 0x0000;	//
	SMBvar_int[SMBV_ChgCurrent ] = 0x0000;	//
	SMBvar_int[SMBV_ChgVoltage ] = 0x0000;	//
*/
	SMBvar_int[SMBV_BattStatus ] = 0x0080;	// sbdat110, 4.4.1
	SMBvar_int[SMBV_CycleCount ] = 0x0000;	// sbdat110, 4.4.1

/* For testing with no calcs
	SMBvar_int[SMBV_DesignCap  ] = 0x0000;	//
	SMBvar_int[SMBV_DesignVolt ] = 0x0000;	//
*/

	SMBvar_int[SMBV_SpecInfo   ] = 0x0031;	// I܂V̎ړxȂ; PECxAV1.1
	SMBvar_int[SMBV_MfrDate    ] = ((2005-1980)<<9)+(8<<5)+(31);	//! \todo ݂̔NŖ܂Bl8iłB
	SMBvar_int[SMBV_SerialNo   ] = 12345;	// Cӂ̒ʔ

	// ǂݍݕϐɂāAKvƂ鎞ɂRAMɏՕɕʂ邱ƂɒӂĂB
	// MfrNameADeviceNameADeviceChemAMfrDatałB

	SetMaxTopAcc((long)6600*10727);		//! \todo pAS[dBOɏlA6600mAh~10727
//	RunningAcc = (long)1000*10727;		// pA0ȊȎ̓_ł̊JnpA1000~10727
}

/* SMBusdl̂̏dvȒ:

JHl(>100k)ł̈SMJڎɌdȓ}Oo邩܂B

޽呕uƂēĂSMBusuُoƁA~𐶐邱Ƃɂ޽ُԂ
߂ƂȂ΂Ȃ܂B

dr͏Ɏg̱ڽɉȂ΂Ȃ܂BȂƁAnŌdȓ݂o
̂ɈSMgƂłƂ͌Adrnɑ݂ȂƕsɎvނƂSMBusνĂ⌫
dr[dɂ邩܂BǂAdrZ̏ꍇAȂΉs\̏ꍇA
ڽɌ㑱ǂ޲ĂȂƂIԂȂƂɒӂĂB͋NꍇAv
ްvĎsׂłB

druڽɑ΂ĎwꂽeSMBusPʏAdrBatteryStatus()L^̉قɓK
Ȉُ필uȂ΂Ȃ܂B̒PʏɊꂽꍇAȏオoȂ
\߂Ɉُ필ׂ͉łBԒ߂ƈُ필^1ŋLqȂُ͖̈m
ُō}邩܂B

ʂ̑uνĂ̒Pʏɓdr֎₵悤Ƃ邩܂BBatteryStatus()̓ǂݍ݂
V̓ǂݍްlɑΉ邱Ƃۏ؂łSȕ@͏ްl̓ǂݍݒɂ
BatteryStatus()̓ǂݍ݂s邱ƂłB͒ȎMSMBus~SMBusJn𔭍s
邱ƂɂĒB邩܂B

޽呕u50s޽ يԌKvƂ܂B

drSMBusۯް̐HighɂȂ̂o鎞ɕKONԂɓ܂Bdr͊łׂ
SMBusHighɂȂ̂o1msSMBusoRŒʐM邱Ƃł܂B

drONԈڍs̍Œ10bԁASMBusνĂ⌫dr[d̂ǂɂChargingVoltage()A
ChargingCurrent()AAlarmWarning()*Ēʕ*үނn߂Ȃ܂B

drONԂɓƁAȉ̒lďȂ΂Ȃ܂B
@\(ްl)			l
---------------------	----------------------------
BatteryMode()	ޯ15: CAPACITY_MODE=0
				ޯ14: CHARGER_MODE=0
				ޯ13: ALARM MODE=0
				ޯ 9: PRIMARY_BATTERY=0
				ޯ 8: CHARGE_CONTROLLER_ENABLED=0


drSMBus̸ۯް̗̐2.5bLowɗ܂鎞ɕKOFFԂֈڍs܂B

(SMBusȊO)x⌫drv邩Ȃްł̑xɐ͂܂BSMBusш
L̐̂߂ɐ܂񂪁Ał̌pް ߰ݸނ\ŋ܂Bdr͍ő25ms
ԁACLOCKLowɕێ邱ƂɂĂǂްvx点邩܂B͗vꂽްTl
ČvZ邽߂Luް擾邽߂ɍs邩܂B

*/
